package SevenZip.Compression.RangeCoder;

import SevenZip.Compression.RangeCoder.Decoder;
public	class BitTreeDecoder {
    BitDecoder[] Models;
    int NumBitLevels;
    
    public BitTreeDecoder(int numBitLevels) {
        NumBitLevels = numBitLevels;
        Models = new BitDecoder[1 << numBitLevels];
        for (int i = 1; i < (1 << NumBitLevels); i++) {
            Models[i] = new BitDecoder();
        }
    }
    
    public final void Init() {
        for (int i = 1; i < (1 << NumBitLevels); i++) {
            Models[i].Init();
        }
    }
    
    public final int Decode(Decoder rangeDecoder) throws java.io.IOException {
        int m = 1;
        for (int bitIndex = NumBitLevels; bitIndex > 0; bitIndex--)
            m = (m << 1) + Models[m].Decode(rangeDecoder);
        return m - (1 << NumBitLevels);
    }
    
    public final int ReverseDecode(Decoder rangeDecoder) throws java.io.IOException {
        int m = 1;
        int symbol = 0;
        for (int bitIndex = 0; bitIndex < NumBitLevels; bitIndex++) {
            int bit = Models[m].Decode(rangeDecoder);
            m <<= 1;
            m += bit;
            symbol |= (bit << bitIndex);
        }
        return symbol;
    }
    
    public static final int ReverseDecode(BitDecoder[] Models, int startIndex,
            Decoder rangeDecoder, int NumBitLevels) throws java.io.IOException {
        int m = 1;
        int symbol = 0;
        for (int bitIndex = 0; bitIndex < NumBitLevels; bitIndex++) {
            int bit = Models[startIndex + m].Decode(rangeDecoder);
            m <<= 1;
            m += bit;
            symbol |= (bit << bitIndex);
        }
        return symbol;
    }
}
