package SevenZip.Compression.RangeCoder;

public	class Encoder {
    static final int kNumTopBits = 24;
    static final int kTopValue = (1 << kNumTopBits);
    public static final int kTopValueMask = ~(kTopValue-1);
    
    static final int kBufferSize = 16384;
    byte [] buffer;
    int bufferPos;
    
    
    
    java.io.OutputStream Stream;
    
    public long Low;
    public int Range;
    int _ffNum;
    int _cache;
    
    long curPosition;
    
    public void SetStream(java.io.OutputStream stream) {
        Stream = stream;
        buffer = new byte[kBufferSize];
        bufferPos=0;
    }
    
    public void ReleaseStream() {
        Stream = null;
        buffer = null;
    }
    
    public void Init() {
        curPosition = 0;
        
        Low = 0;
        Range = -1; // 0xFFFFFFFFL;
        _ffNum = 0;
        _cache = 0;
    }
    
    public void FlushData() throws java.io.IOException {
        for (int i = 0; i < 5; i++)
            ShiftLow();
    }
    
    public void FlushStream() throws java.io.IOException {
        if (bufferPos >= 1)
            Stream.write(buffer,0,bufferPos);
        
        Stream.flush();
    }
    
    public void writeStream(int val) throws java.io.IOException {
        buffer[bufferPos++] = (byte)val;
        if (bufferPos == kBufferSize) {
            Stream.write(buffer);
            bufferPos = 0;
        }
    }
    
    public void ShiftLow() throws java.io.IOException {
        if (Low < 0xFF000000L || (Low >> 32) == 1) {
            writeStream(_cache + (int)(Low >> 32));
            curPosition++;
            for (; _ffNum != 0; _ffNum--) {
                writeStream((0xFF + (int)(Low >> 32)));
                curPosition++;
            }
            _cache = (((int)Low) >> 24);
        } else
            _ffNum++;
        Low = (Low & 0xFFFFFF) << 8;  // Low = ((u_int)Low) << 8;
    }
    
    public void EncodeDirectBits(int v, int numTotalBits) throws java.io.IOException {
        for (int i = numTotalBits - 1; i >= 0; i--) {
            Range >>>= 1;
            if (((v >> i) & 1) == 1)
                Low += (Range & 0xFFFFFFFFL);
            if ((Range & Encoder.kTopValueMask) == 0) // (Range < kTopValue)
            {
                Range <<= 8;
                ShiftLow();
            }
        }
    }
    
    public long GetProcessedSizeAdd() {
        return _ffNum + curPosition;
    }
}

